(function controller(args) {
  'use strict';

  //Fix1
  /*$.removeListener = function(proxy, type, callback) {
			$.__events.forEach(function(event, index) {
				if ((!proxy || proxy.id === event.id) &&
					(!type || type === event.type) &&
					(!callback || callback === event.handler)) {
					event.view.removeEventListener(event.type, event.handler);
					delete $.__events[index];
				}
			});
			return $;
		};*/

  //Fix2
  /*$.removeListener = function(proxy, type, callback) {
			_.each($.__events, function(event, index) {
				if (event && (!proxy || proxy.id === event.id) &&
					(!type || type === event.type) &&
					(!callback || callback === event.handler)) {
					event.view.removeEventListener(event.type, event.handler);
					delete $.__events[index];
				}
			});
			return $;
		};*/

  (function addListener() {
    Ti.API.info('Add listener handlers');
    $.addListener($.win, 'open', disableClick);
    $.addListener($.win, 'close', clean);
    $.addListener($.disable, 'click', disableClick);
    $.addListener($.label, 'click', close);
    //showListeners();
  })();

  function showListeners(){
    Ti.API.info('Show listener handlers');

    Ti.API.error('__events is an Array? ' + Array.isArray($.__events));

    $.__events.forEach(function(event, index){
      Ti.API.info(JSON.stringify({
        id: event.id,
        type: event.type,
        events: event._events,
        index: index
      }));
    });
  }

  function disableClick() {
    Ti.API.info('Removing $.disable listener handler');
    $.removeListener($.disable, 'click', disableClick);
    //showListeners();
  }

  function close(e) {
    Ti.API.info('Closing window');
    $.win.close();
  }

  function clean(e) {
    Ti.API.info('Cleaning window');
    //showListeners();
    try {
      Ti.API.info('Call $.removeListener()');
      $.removeListener();
    } catch (err) {
      Ti.API.error('Error catched: ' + err.message);
    }
  }

})(arguments[0] || {});
